/****************************************************************************
 * UniPROG Universal programmer 
 * Device algoritms
 * 
 * Daniel Quintero <danielqg@infonegocio.com>
 *
 * 06/06/2001 - First version, Atmel algoritms only
 *              fixed to eep programmer
 * 07/09/2003 - Ported to new multi-programmer architecture
 *
 */

#ifndef ALGORITHMS_H
#define ALGORITHMS_H

#include "stdhdr.h"
#include "chipdb.h"

/*  Table based, some day...
typedef LRESULT (CALLBACK* WNDPROC)(HWND, UINT, WPARAM, LPARAM);

typedef struct {
  int (read   *)(unsigned char *buf, long size, long addr);
  int (write  *)(unsigned char *buf, long size, long addr);
  int (verify *)(unsigned char *buf, long size, long addr);
  char* (getDesc *) ( void );
  } ALGORITHM;
*/

// Error constants

#define AL_NOERR      0
#define AL_ERRTIMEOUT 1
#define AL_ERRVERIFY  2

// Stub based, more easy



// Generic Algoritms (read only)

int genReadBlock(unsigned char *buf, unsigned int size, long addr);

int ramWriteSector(unsigned char *buf, unsigned int size, long addr, CHIPREG *chip);

int CheckHardware( void );
int genVccOn( void );
int genVccOff( void );

// Atmel 29x Functions

int atGetID( unsigned int *ID );
int atWriteSector(unsigned char *buf, unsigned int size, long addr, CHIPREG *chip);
int atVerifySector(unsigned char *buf, unsigned int size, long addr, CHIPREG *chip);
int atErase( void );

/* AMD 29F0x0 functions */

int amGetSectorProtection( void );


#endif // ALGORITHMS_H
