/****************************************************************************
 * UniPROG Universal programmer 
 * Frohwein-Sshua Flash Programmer support
 * 
 * Daniel Quintero <danielqg@infonegocio.com>
 *
 * 20/05/2001 - First version, Test hardware
 * 06/06/2001 - Added eepWriteByte, is more generic
 * 07/09/2003 - Ported to new multiprogrammer architecture
 */

#ifndef EEPROG_H
#define EEPROG_H

// Functions

// Mandatory
int    eepInit( void );
int    eepOpen( struct prog_dev * );
int    eepClose( struct prog_dev * );
unsigned char eepReadByteAddr(struct prog_dev * , long addr);
void   eepWriteByteAddr(struct prog_dev * , long addr, unsigned char val);
int    eepCheckHard( struct prog_dev *pd, int );
void   eepReadBlock(unsigned char *pBlock, long blockSize);

// Specific
unsigned char   eepReadByte( void );
void   eepWriteByte( unsigned char val );
void   eepSetWE ( int value );
void   eepSetRD ( int value );
void   eepSetWOE ( int value );
void   eepSetAddr ( long Addr );
void   eepIncAddr( void );
long   eepGetAddr( void );


#endif // EEPROG_H

