/****************************************************************************
 * UniPROG Universal programmer 
 * Command line parser
 * 
 * Daniel Quintero <danielqg@infonegocio.com>
 *
 * 04/05/2001 - First version
 *
 */

#define INTEGER		0
#define BOOLEAN		1
#define CHARACTER	2
#define STRING		3
#define PROC		4
#define GROUP           5       // list of switches, only one active at time

// Arguments is defined on ARG.key member, on regular params consists in a
// comma separated list of sinomys args, on GROUP type this list order also
// mean the arg value in the group

typedef const struct {
  char *key;            // Arg key
  int  type;            // Type of value
  char *errmsg;         // Description
  int  *val;            // pointer to value
  int  mandatory;       // parameter is mandatory
  int  used;            // (internal use), Arg in use
  } ARG;

// Analyze the command line, the arguments is defined in argTable
int argParse( int argc, char *argv[], ARG *argTable, int argTableSize );
void argPrintUsage(ARG *pArg, int nArg);

