/****************************************************************************
 * UniPROG Universal programmer 
 * Command line parser
 * 
 * Daniel Quintero <danielqg@infonegocio.com>
 *
 * 20/05/2001 - First version, Use direct hardware
 * 21/08/2003 - Added timing fuctions for linux
 *              TODO : Update in-line asm for compile with gcc
 */

#include "stdhdr.h"
#include "portio.h"

/* Direct I/O Functions */

#ifdef USE_DIRECT_IO

void outp(WORD port, BYTE data) {
  asm {
        mov al,data
        mov dx,port
        out dx,al
      }
  }


BYTE inp(WORD port) {
  BYTE data;
  asm {
        mov dx,port
        in  al,dx
        mov data,al
      }
  return data;
  }

#endif

#ifdef __LINUX__

long getms( void ) {
	struct timeval tv;

	gettimeofday(&tv, NULL);
	return tv.tv_usec / 1000;
}

#endif


