/****************************************************************************
 * UniPROG Universal programmer 
 * Willem programmer support
 * 
 * Daniel Quintero <danielqg@infonegocio.com>
 *
 * 23/07/2003 - First version
 */

#ifndef WILLEM_H
#define WILLEM_H

/* Willem io-macros */

#define EIN 128       
#define outhi clkhi
#define outlo clklo
#define IN2 64
#define POW 4         
#define RW  2
#define PP  1
#define PGM 8
#define ADR 2
#define CLK 1
#define CLA 4
#define CTW 160
#define CTR 161
#define BIC 0x20

#define einbit  (INPORT(wilStatusPort)&EIN)
#define inbit   (INPORT(wilStatusPort)&IN2)
#define powoff  (wilControl &= ~POW)
#define powon   (wilControl |= POW)
#define read    (wilControl &= ~RW)
#define write   (wilControl |= RW)
#define pgrhi   (wilControl &= ~PGM)
#define pgrlo   (wilControl |= PGM)
#define ppoff   (wilControl |= PP)
#define ppon    (wilControl &= ~PP)
#define adrlo   (wilData &= ~ADR)
#define adrhi   (wilData |= ADR)
#define clklo   (wilData &= ~CLK)
#define clkhi   (wilData |= CLK)
#define clalo   (wilData |=CLA)
#define clahi   (wilData &=~CLA)

#define assert_ctrl  (OUTPORT(wilCtrlPort,wilControl)) 
#define assert_data (OUTPORT(wilDataPort,wilData))
//-------------------------------------------------

#define WE_High     {pgrhi;assert_ctrl;}     // WE, code 8 = C17/S4 Pin 31 High
#define WE_Low      {pgrlo;assert_ctrl;}     // WE, code 8 = C17/S4 Pin 31 Low
#define OE_High     {write;assert_ctrl;}     // OE, code 2 = S6 high
#define OE_Low      {read;assert_ctrl;}      // OE, code 2 = S6 low
#define VPP_On      {ppon;assert_ctrl;}      // VPP, code 1 = C1 12v
#define VPP_Off     {ppoff;assert_ctrl;}     // VPP, code 1 = C1 0v
#define VCC_On      {powon;assert_ctrl;}     // VCC, code 4 = Vcc 5V
#define VCC_Off     {powoff;assert_ctrl;}    // VCC, code 4 = Vcc 0V

/* Functions */

/* Mandatory */
int    wilInit( void );
int    wilOpen( struct prog_dev * );
int    wilClose( struct prog_dev * );
int    wilExecCommand( int cmd, void *ptr, int par1, int par2);
unsigned char   wilReadByteAddr(struct prog_dev * , long addr);
void   wilWriteByteAddr(struct prog_dev * , long addr, unsigned char val);
void   wilReadBlock(unsigned char *pBlock, long blockSize);
int    wilCheckHard( struct prog_dev *pd, int );

/* Specific */

int wilPowerDown(void);
int wilPowerOn(void); 

unsigned char   wilReadByte( void );
void   wilWriteByte( unsigned char val );

/*
void   eepSetWE ( int value );
void   eepSetRD ( int value );
void   eepSetWOE ( int value );
*/
void   wilSetAddr ( long Addr );
void   wilIncAddr( void );
long   wilGetAddr( void );


#endif // EEPROG_H

